<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_job_order_task');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_JORDER_TASK_ID',
					'PARAM_REC_JORDER_TASK_DESCRIPTION',
					'PARAM_REC_JORDER_TASK_REMARKS',
					'PARAM_REC_JORDER_TASK_QTY_TARGET_FROM',
					'PARAM_REC_JORDER_TASK_QTY_TARGET_TO',
					'PARAM_REC_JORDER_TASK_QTY_ACTUAL_FROM',
					'PARAM_REC_JORDER_TASK_QTY_ACTUAL_TO',
					'PARAM_REC_JORDER_TASK_AMT_TARGET_FROM',
					'PARAM_REC_JORDER_TASK_AMT_TARGET_TO',
					'PARAM_REC_JORDER_TASK_AMT_ACTUAL_FROM',
					'PARAM_REC_JORDER_TASK_AMT_ACTUAL_TO',
					'PARAM_REC_JORDER_TASK_LONG_A_FROM',
					'PARAM_REC_JORDER_TASK_LONG_A_TO',
					'PARAM_REC_JORDER_TASK_LONG_B_FROM',
					'PARAM_REC_JORDER_TASK_LONG_B_TO',
					'PARAM_REC_JORDER_TASK_DECIMAL_A_FROM',
					'PARAM_REC_JORDER_TASK_DECIMAL_A_TO',
					'PARAM_REC_JORDER_TASK_DECIMAL_B_FROM',
					'PARAM_REC_JORDER_TASK_DECIMAL_B_TO',
					'PARAM_REC_JORDER_TASK_VARCHAR_A',
					'PARAM_REC_JORDER_TASK_VARCHAR_B',
					'PARAM_REC_JORDER_TASK_DATETIME_A_FROM',
					'PARAM_REC_JORDER_TASK_DATETIME_A_TO',
					'PARAM_REC_JORDER_TASK_DATETIME_B_FROM',
					'PARAM_REC_JORDER_TASK_DATETIME_B_TO',
					'PARAM_REC_JORDER_TASK_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_JORDER_TASK_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_ID');
			$PARAM_REC_JORDER_TASK_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_DESCRIPTION');
			$PARAM_REC_JORDER_TASK_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_REMARKS');
			$PARAM_REC_JORDER_TASK_QTY_TARGET_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_TARGET_FROM');
			$PARAM_REC_JORDER_TASK_QTY_TARGET_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_TARGET_TO');
			$PARAM_REC_JORDER_TASK_QTY_ACTUAL_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_ACTUAL_FROM');
			$PARAM_REC_JORDER_TASK_QTY_ACTUAL_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_ACTUAL_TO');
			$PARAM_REC_JORDER_TASK_AMT_TARGET_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_TARGET_FROM');
			$PARAM_REC_JORDER_TASK_AMT_TARGET_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_TARGET_TO');
			$PARAM_REC_JORDER_TASK_AMT_ACTUAL_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_ACTUAL_FROM');
			$PARAM_REC_JORDER_TASK_AMT_ACTUAL_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_ACTUAL_TO');
			$PARAM_REC_JORDER_TASK_LONG_A_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_A_FROM');
			$PARAM_REC_JORDER_TASK_LONG_A_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_A_TO');
			$PARAM_REC_JORDER_TASK_LONG_B_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_B_FROM');
			$PARAM_REC_JORDER_TASK_LONG_B_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_B_TO');
			$PARAM_REC_JORDER_TASK_DECIMAL_A_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_A_FROM');
			$PARAM_REC_JORDER_TASK_DECIMAL_A_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_A_TO');
			$PARAM_REC_JORDER_TASK_DECIMAL_B_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_B_FROM');
			$PARAM_REC_JORDER_TASK_DECIMAL_B_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_B_TO');
			$PARAM_REC_JORDER_TASK_VARCHAR_A = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_VARCHAR_A');
			$PARAM_REC_JORDER_TASK_VARCHAR_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_VARCHAR_B');
			$PARAM_REC_JORDER_TASK_DATETIME_A_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_A_FROM');
			$PARAM_REC_JORDER_TASK_DATETIME_A_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_A_TO');
			$PARAM_REC_JORDER_TASK_DATETIME_B_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_B_FROM');
			$PARAM_REC_JORDER_TASK_DATETIME_B_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_B_TO');
			$PARAM_REC_JORDER_TASK_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_JORDER_TASK_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_JORDER_TASK_ID', 
						'REC_JORDER_TASK_DESCRIPTION', 
						'REC_JORDER_TASK_REMARKS', 
						'REC_JORDER_TASK_QTY_TARGET', 
						'REC_JORDER_TASK_QTY_ACTUAL', 
						'REC_JORDER_TASK_AMT_TARGET', 
						'REC_JORDER_TASK_AMT_ACTUAL', 
						'REC_JORDER_TASK_LONG_A', 
						'REC_JORDER_TASK_LONG_B', 
						'REC_JORDER_TASK_DECIMAL_A', 
						'REC_JORDER_TASK_DECIMAL_B', 
						'REC_JORDER_TASK_VARCHAR_A', 
						'REC_JORDER_TASK_VARCHAR_B', 
						'REC_JORDER_TASK_DATETIME_A', 
						'REC_JORDER_TASK_DATETIME_B', 
						'REC_JORDER_TASK_STATUS'
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_JOB_ORDER_TASK::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_ID'] = $PARAM_REC_JORDER_TASK_ID;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DESCRIPTION'] = $PARAM_REC_JORDER_TASK_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_REMARKS'] = $PARAM_REC_JORDER_TASK_REMARKS;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_TARGET_FROM'] = $PARAM_REC_JORDER_TASK_QTY_TARGET_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_TARGET_TO'] = $PARAM_REC_JORDER_TASK_QTY_TARGET_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_ACTUAL_FROM'] = $PARAM_REC_JORDER_TASK_QTY_ACTUAL_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_ACTUAL_TO'] = $PARAM_REC_JORDER_TASK_QTY_ACTUAL_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_TARGET_FROM'] = $PARAM_REC_JORDER_TASK_AMT_TARGET_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_TARGET_TO'] = $PARAM_REC_JORDER_TASK_AMT_TARGET_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_ACTUAL_FROM'] = $PARAM_REC_JORDER_TASK_AMT_ACTUAL_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_ACTUAL_TO'] = $PARAM_REC_JORDER_TASK_AMT_ACTUAL_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_A_FROM'] = $PARAM_REC_JORDER_TASK_LONG_A_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_A_TO'] = $PARAM_REC_JORDER_TASK_LONG_A_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_B_FROM'] = $PARAM_REC_JORDER_TASK_LONG_B_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_B_TO'] = $PARAM_REC_JORDER_TASK_LONG_B_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_A_FROM'] = $PARAM_REC_JORDER_TASK_DECIMAL_A_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_A_TO'] = $PARAM_REC_JORDER_TASK_DECIMAL_A_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_B_FROM'] = $PARAM_REC_JORDER_TASK_DECIMAL_B_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_B_TO'] = $PARAM_REC_JORDER_TASK_DECIMAL_B_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_VARCHAR_A'] = $PARAM_REC_JORDER_TASK_VARCHAR_A;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_VARCHAR_B'] = $PARAM_REC_JORDER_TASK_VARCHAR_B;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_A_FROM'] = $PARAM_REC_JORDER_TASK_DATETIME_A_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_A_TO'] = $PARAM_REC_JORDER_TASK_DATETIME_A_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_B_FROM'] = $PARAM_REC_JORDER_TASK_DATETIME_B_FROM;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_B_TO'] = $PARAM_REC_JORDER_TASK_DATETIME_B_TO;
			$GET_MAP_ARRAY['PARAM_REC_JORDER_TASK_STATUS'] = $PARAM_REC_JORDER_TASK_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_JOB_ORDER_TASK::CUS_GET_LITE_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>